--- old/usr/src/head/link.h	2012-10-11 22:38:20.910809202 -0400
+++ new/usr/src/head/link.h	2012-10-11 22:38:20.922349311 -0400
@@ -28,7 +28,7 @@
 #include <sys/link.h>
 
 #ifndef _ASM
-#include <libelf.h>
+#include <elf.h>
 #include <sys/types.h>
 #include <dlfcn.h>
 #endif
@@ -39,9 +39,14 @@
 
 #ifndef _ASM
 /*
- * ld support library calls
+ * ld support library calls.
+ *
+ * These cannot be used in a 32bit large file capable environment,
+ * thanks to the use of libelf.
  */
+#if !defined(_ILP32) || _FILE_OFFSET_BITS != 64
 #ifdef __STDC__
+#include <libelf.h>
 extern uint_t	ld_version(uint_t);
 extern void	ld_input_done(uint_t *);
 
@@ -88,6 +93,7 @@
 
 #endif /* (defined(_LP64) || defined(_LONGLONG_TYPE) */
 #endif /* __STDC__ */
+#endif /* !defined(_ILP32) || _FILE_OFFSET_BITS != 64 */
 
 /*
  * ld_version() version values.
